package com.wall.dream.wallpapers.acacctivity

import android.content.Intent
import android.os.Bundle
import android.view.View
import android.view.inputmethod.EditorInfo
import android.view.inputmethod.InputMethodManager
import android.widget.TextView.OnEditorActionListener
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import androidx.recyclerview.widget.GridLayoutManager
import com.wall.dream.wallpapers.R
import com.wall.dream.wallpapers.databinding.ViewSearchBinding
import com.wall.dream.wallpapers.GJ.ComUtilsGJ
import com.wall.dream.wallpapers.GJ.ObectBoxManagerGJ
import com.wall.dream.wallpapers.GJ.ItemHelperGJ
import com.wall.dream.wallpapers.LianXi.OnItemXianClick
import com.wall.dream.wallpapers.data.DataBase
import com.wall.dream.wallpapers.ItemPag.ItemListPag

class SearchViewActivity : AppCompatActivity() ,
    OnItemXianClick {
    private lateinit var adapterWallapper: ItemListPag
    private lateinit var binding: ViewSearchBinding
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = ViewSearchBinding.inflate(layoutInflater)
        setContentView(binding.root)
        ComUtilsGJ.initFull(this, false)
        initList()
        binding.imageviewBack.setOnClickListener {
            finish()
        }
    }


    private fun initList() {
        val height = ComUtilsGJ.dp2Px(180)
        adapterWallapper =
            ItemListPag(this, height, true)
        adapterWallapper.setInfoWallpaperListener(this)
        val recyclerItemHelperGJ = ItemHelperGJ(10, 10, 15)
        val gridLayoutManager = GridLayoutManager(this, 2)
        binding.resultRecycler.run {
            layoutManager = gridLayoutManager
            addItemDecoration(recyclerItemHelperGJ)
            adapter = adapterWallapper
        }

        binding.et.setOnEditorActionListener(OnEditorActionListener { v, actionId, event ->
            if (actionId == EditorInfo.IME_ACTION_SEARCH) {
                startSearch()
                return@OnEditorActionListener true
            }
            false
        })
        binding.btnSearch.setOnClickListener { startSearch() }
    }

    private fun closeKeyboard() {
        val imm =  getSystemService(INPUT_METHOD_SERVICE) as InputMethodManager
        imm.hideSoftInputFromWindow(binding.et.windowToken, 0)
    }

    private fun startSearch() {
        closeKeyboard()
        binding.searchPb.visibility = View.VISIBLE
        val string: String = binding.et.text.toString()
        if (string.isNotEmpty()) {
            val search = ObectBoxManagerGJ.search(string)
            if (search.size > 0) {
                showEmpty(false)
                adapterWallapper.setDataInfo(search)
                binding.searchPb.visibility = View.GONE
            } else {
                binding.searchPb.visibility = View.GONE
                showEmpty(true)
            }

        } else {
            binding.searchPb.visibility = View.GONE
            Toast.makeText(
                this,
                getString(R.string.please_input_keyword),
                Toast.LENGTH_SHORT
            ).show()
        }
    }

    private fun showEmpty(showEmpty: Boolean) {
        if (showEmpty) {
            binding.emptyLayout.visibility = View.VISIBLE
            binding.resultRecycler.visibility = View.GONE
        } else {
            binding.emptyLayout.visibility = View.GONE
            binding.resultRecycler.visibility = View.VISIBLE
        }
    }

    override fun onItemClickAction(info: DataBase?) {
        val intent = Intent(this, WallpaperViewActivity::class.java)
        intent.putExtra(ComUtilsGJ.key_info, info)
        startActivity(intent)
    }
}